//ce fichier contient de quoi manipuler des matrices 2x2

#include <stdio.h>
#include <math.h>
#include "complexes.h"
#include "Matrices.h"

typedef unsigned long uint;

/*
inline nombre abs (nombre n)
{
	if (n >= 0)
		return n;
	return -n;
}

inline nombre min (nombre a, nombre b)
{
	if (a < b)
		return a;
	return b;
}
*/

inline nombre Matrice::Det ()
{
	return m[0][0]*m[1][1]-m[0][1]*m[1][0];
}

inline void Matrice::inverse ()
{
	nombre tamp;
	nombre det = Det();
	tamp = m[0][0];
	m[0][0] = m[1][1]/det;
	m[1][1] = tamp/det;
	m[0][1] = -m[0][1]/det;
	m[1][0] = -m[1][0]/det;
}

inline void Matrice::inverse2 ()
{
	nombre tamp;
	tamp = m[0][0];
	m[0][0] = m[1][1];
	m[1][1] = tamp;
	m[0][1] = -m[0][1];
	m[1][0] = -m[1][0];
}

inline bool Matrice::equal (Matrice m2)
{
	return (m[0][0] == m2.m[0][0] && m[0][1] == m2.m[0][1] && m[1][0] == m2.m[1][0] && m[1][1] == m2.m[1][1]);
}

inline nombre Matrice::f ()
{
	return m[0][0]+m[0][1]*2+m[1][0]*2+m[1][1]*4;
}

inline nombre Matrice::Trace ()
{
	return m[0][0]+m[1][1];
}

inline nombre Matrice::Discr ()
{
	nombre r;
	r = m[0][0]-m[1][1];
	r = r*r;
	r = r + m[0][1]*m[1][0]*4;
	return r;
}

/*
bool Matrice::M ()
{
	return (abs(Det()) == 1 && abs(m[0][1]-m[1][0]) < m[1][1] - m[0][0]);
}
*/

//bool Matrice::M (uint n) //la matrice s'ecrit comme produit de chiffres <= n ?

/*uint Matrice::chiffreg ()
{
	uint c;
	if (m[0][0] == 0 || m[1][0] == 0)
	{
		c = m[1][1];
	}else
	{
		c = min(m[0][1]/m[0][0], m[1][1]/m[1][0]);
	}
	return c;
}

uint Matrice::chiffres (uint *chiffres)
{
	Matrice m;
	m.set(*this);
	uint i;
	nombre c;
	uint n = 0;
	for (i=0;i<40;i++)
	{
		if (m.m[0][0] == 0 || m.m[1][0] == 0)
		{
			c = m.m[1][1];
		}else
		{
			c = min(m.m[0][1]/m.m[0][0], m.m[1][1]/m.m[1][0]);
		}
		//printf("%d ",c);
		chiffres[n] = c; //mpz_get_ui( c.n);
		n++;
		//m.disp();
		m.div(c);
		if (m.isunit())
			break;
	}
	//printf("\n");
	return n;
}
*/

/*
void Matrice::dispc ()
{
	Matrice m;
	m.set(*this);
	uint i;
	nombre c;
	if (m.isunit())
	{
		printf("I ");
		return;
	}
	for (i=0;i<40;i++)
	{
		if (m.m[0][0] == 0 || m.m[1][0] == 0)
		{
			c = m.m[1][1];
		}else
		{
			c = min(m.m[0][1]/m.m[0][0], m.m[1][1]/m.m[1][0]);
			//printf("min (%d, %d) = %d\n", m.m[0][1]/m.m[0][0], m.m[1][1]/m.m[1][0], c);
		}
		if (c == 0)
			break;
		printf("%ld ", (long)c); //mpz_get_ui( c.n));
		//m.disp();
		m.div(c);
		if (m.isunit())
			break;
	}
}
*/

inline void Matrice::set (Matrice M)
{
	m[0][0] = M.m[0][0];
	m[0][1] = M.m[0][1];
	m[1][0] = M.m[1][0];
	m[1][1] = M.m[1][1];
}

inline void Matrice::mul (nombre a) //multiplie la matrice par un scalaire
{
	m[0][0] *= a;
	m[0][1] *= a;
	m[1][0] *= a;
	m[1][1] *= a;
}

inline void Matrice::prod (nombre i)
{
	nombre tamp;
	tamp = m[0][0];
	m[0][0] = m[0][1];
	m[0][1] = tamp + i*m[0][1];
	tamp = m[1][0];
	m[1][0] = m[1][1];
	m[1][1] = tamp + i*m[1][1];
}

inline void Matrice::div (nombre i)
{
	nombre tamp;
	tamp = m[0][1];
	m[0][1] = m[0][0];
	m[0][0] = tamp - i*m[0][0];
	tamp = m[1][1];
	m[1][1] = m[1][0];
	m[1][0] = tamp - i*m[1][0];
}
/*
inline void Matrice::prod (uint i)
{
	nombre tamp;
	tamp = m[0][0];
	m[0][0] = m[0][1];
	m[0][1] = tamp + m[0][1]*i;
	tamp = m[1][0];
	m[1][0] = m[1][1];
	m[1][1] = tamp + m[1][1]*i;
}

inline void Matrice::div (uint i)
{
	nombre tamp;
	tamp = m[0][1];
	m[0][1] = m[0][0];
	m[0][0] = tamp - m[0][0]*i;
	tamp = m[1][1];
	m[1][1] = m[1][0];
	m[1][0] = tamp - m[1][0]*i;
}
*/

inline void Matrice::Transpose ()
{
	nombre tamp;
	tamp = m[0][1];
	m[0][1] = m[1][0];
	m[1][0] = tamp;
}

bool Matrice::isunit ()
{
	return ((m[0][0] == 1) && (m[0][1] == 0) && (m[1][0] == 0) && (m[1][1] == 1));
}

#define EPSILON .000000001

bool isint (float d)
{
	//printf("%lf\n", d - (int)(d+.5));
	return fabs(d - (int)(d+.5)) < EPSILON; //(abs(abs(d) - (nombre)((int)abs(d))) < EPSILON);
}

bool isint (Complexe c)
{
	//printf("%lf\n", d - (int)(d+.5));
	return fabs(c.x - (int)(c.x+.5)) < EPSILON && fabs(c.y) < EPSILON; //(abs(abs(d) - (nombre)((int)abs(d))) < EPSILON);
}

bool Matrice::is_int ()
{
	return (isint(m[0][0]) && isint(m[0][1]) && isint(m[1][0]) && isint(m[1][1]));
}

void Matrice::unit () //matrice unité
{
	uint i,j;
	for (i=0;i<2;i++)
	{
		for (j=0;j<2;j++)
		{
			m[i][j] = r(0);
		}
		m[i][i] = r(1);
	}
}

Matrice Matrice::prod (Matrice M)
{
	Matrice M2;
	M2.m[0][0] = m[0][0]*M.m[0][0] + m[0][1]*M.m[1][0];
	M2.m[0][1] = m[0][0]*M.m[0][1] + m[0][1]*M.m[1][1];
	M2.m[1][0] = m[1][0]*M.m[0][0] + m[1][1]*M.m[1][0];
	M2.m[1][1] = m[1][0]*M.m[0][1] + m[1][1]*M.m[1][1];
	return M2;
}

Matrice Matrice::prod (nombre a, nombre b, nombre c, nombre d)
{
	Matrice M2;
	M2.m[0][0] = m[0][0]*a + m[0][1]*c;
	M2.m[0][1] = m[0][0]*b + m[0][1]*d;
	M2.m[1][0] = m[1][0]*a + m[1][1]*c;
	M2.m[1][1] = m[1][0]*b + m[1][1]*d;
	return M2;
}

inline Matrice Matrice::sub (Matrice M)
{
	Matrice M2;
	M2.m[0][0] = m[0][0] - M.m[0][0];
	M2.m[0][1] = m[0][1] - M.m[0][1];
	M2.m[1][0] = m[1][0] - M.m[1][0];
	M2.m[1][1] = m[1][1] - M.m[1][1];
	return M2;
}

inline Matrice Matrice::add (Matrice M)
{
	Matrice M2;
	M2.m[0][0] = m[0][0] + M.m[0][0];
	M2.m[0][1] = m[0][1] + M.m[0][1];
	M2.m[1][0] = m[1][0] + M.m[1][0];
	M2.m[1][1] = m[1][1] + M.m[1][1];
	return M2;
}

/*
//initialise avec la matrice correspondant à [1,1,...,1] (n fois) (n doit être >= 1)
inline void Matrice::init1 (ull n)
{
	//printf("init1 (%d) ...\n",n);
	if (n+1 >= nc)
	{
		fprintf(stderr, "Erreur : depassement de f (%d >= %d) !\n", (int)(n+1), (int)nc);
		err = true;
		return;
	}
	m[0][0] = f[n-1];
	m[1][0] = m[0][1] = f[n];
	m[1][1] = f[n+1];
	//disp ();
}

//initialise avec la matrice correspondant à [2,2,...,2] (n fois) (n doit être >= 1)
inline void Matrice::init2 (ull n)
{
	if (n+1 >= nc)
	{
		fprintf(stderr, "Erreur : depassement de g (%d >= %d) !\n", (int)(n+1), (int)nc);
		err = true;
		return;
	}
	m[0][0] = g[n-1];
	m[1][0] = m[0][1] = g[n];
	m[1][1] = g[n+1];
}
 */

/*
inline void Matrice::Discr (mpz_t res)
{
	mpz_t t;
	mpz_init_set_ui (t, m[1][1]-m[0][0]);//res.Carre(m[1][1]-m[0][0]);
	mpz_mul_ui (res, t, m[1][1]-m[0][0]);
	mpz_set_ui (t, m[0][1]);//t.prod(m[0][1], m[1][0]);
	mpz_mul_ui (t, t, m[1][0]);//t.prod(m[0][1], m[1][0]);
	mpz_addmul_ui (res, t, 4); //res.Add(t);
	mpz_clear(t);
}
*/

//affiche la matrice
void Matrice::disp ()
{
	uint i,j;
	//printf("[");
	for (j=0;j<2;j++)
	{
		printf(" [");
		for (i=0;i<2;i++)
		{
			//printf(" %ld", (long)m[i][j]); //mpz_get_ui(m[i][j].n) );
			printf(" %lf + %lf*I", (double)m[i][j].x, (double)m[i][j].y);
		}
		printf(" ]\n");
	}
	printf("\n");
}

