#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <pari/pari.h>
#include <SDL/SDL.h>
#include <time.h>
//#include <jpeglib.h>
#include "resize.h"
#include "complexes.h"
#include "Matrices.h"

#define QUALITY	2 //niveau de qualité de l'image produite

#define VERB	10

SDL_Surface *ecran;

#define DX2	3264 //dimensions de l'image réduite qui sera enregistrée
#define DY2	2448

#define	FX	(DX2/4) //dimensions de la fenetre
#define FY	(DY2/4)

#if QUALITY == 0
	#define DX	FX //16000 //dimensions de l'image produite
	#define DY	FY //16000
#elif QUALITY == 1
	#define DX	DX2 //16000 //dimensions de l'image produite
	#define DY	DY2 //16000
#elif QUALITY == 2
	#define DX	(4*DX2) //16000 //dimensions de l'image produite
	#define DY	(4*DY2) //16000
#elif QUALITY == 3
	#define DX	(8*DX2) //16000 //dimensions de l'image produite
	#define DY	(8*DY2) //16000
#else
	#define DX	(16*DX2) //16000 //dimensions de l'image produite
	#define DY	(16*DX2) //16000
#endif

double SX	= 5; //tailles de la zone calculé
double SY	= 5;
double CX	= 0; //-1.1 //centre
double CY	= 0; //1.

#define FIN	.1 //grosseur du tracé avec Draw4

double bord = .02;
#define PRECB	80 //précisions des bornes
int TRMAX = 2; //10; //nombre max de secondes pour calculer les bornes par la première méthode

int NG	 = 2; //nombre de générateurs
//GEN beta;
GEN *g; //[NG]; //générateurs (matrices 2x2 complexes)
Matrice *gf; //[NG]; //générateurs (matrices 2x2 complexes)
long prec = 6;
#if QUALITY <= 1
	int NITER	= 500000; //nombre d'itérations
#elif QUALITY == 2
	int NITER	= 2000000; //nombre d'itérations
#else
	int NITER	= 4000000; //nombre d'itérations
#endif
#define NITERB	100000000 //nombre d'itérations pour trouver les bornes

#define MORC	10 //nombre d'itérations calculées d'un seul coup

#if QUALITY <= 1
	#define NITER2	80 //nombre d'itérations pour la majoration
#elif QUALITY == 2
	#define NITER2	30
#elif QUALITY == 3
	#define NITER2	80
#else
	#define NITER2	50
#endif

GEN infini;

GEN SX_, SY_, CX_, CY_;

Uint32 color0;

GEN apply (GEN c, int gen); //applique le générateur gen au complexe c
GEN apply (GEN m, GEN c); //applique la matrice m au complexe c
GEN Find1 (); //cherche 1 point dans l'ensemble limite
GEN fix (GEN p1, GEN p2, GEN p); //trouve une isométrie de points fixes p1, p2, et avec un paramètre complexe p
void SaveJPEG (SDL_Surface *s, const char * filename);
void CtoD (GEN c, double *x, double *y);
GEN DtoC (double x, double y);

void DispS (SDL_Surface *s)
{
	Copy(s, ecran, NULL);
	SDL_Flip(ecran);
}

void SaveJPEG (SDL_Surface *s, const char * filename)
{
	FILE *f = fopen("data", "w+");
	if (!f)
	{
		printf("Impossible d'ouvrir le fichier data !\n");
		return;
	}
	
	unsigned int dx = s->w;
	unsigned int dy = s->h;
	
	fwrite(&dx, sizeof(dx), 1, f);
	fwrite(&dy, sizeof(dy), 1, f);
	
	int x,y;
	Uint8 r, v, b;
	Uint32 *pix = (Uint32 *)s->pixels;
	for (y=0;y<dy;y++)
	{
		for (x=0;x<dx;x++)
		{
			SDL_GetRGB(*pix, s->format, &r, &v, &b);
			fwrite(&r, 1, 1, f);
			fwrite(&v, 1, 1, f);
			fwrite(&b, 1, 1, f);
			pix++;
		}
		pix += (s->pitch/4 - s->w);
	}
	fclose(f);
	
	char tamp[1024];
	sprintf(tamp, "./jpeg %s", filename);
	system(tamp);
}

void DrawMaj (SDL_Surface *s)
{
	Uint32 color = SDL_MapRGB(s->format, 0, 0, 255);
	/*
	SDL_FillRect(s, NULL, color0);
	SDL_Rect r;
	r.x = bord*DX;
	r.y = bord*DY;
	r.w = DX*(1. - bord);
	r.h = DY*(1. - 2*bord);
	SDL_FillRect(s, &r, color);
	*/
	SDL_FillRect(s, NULL, color);
	
	/*
	int i,j;
	//Uint32 color0 = SDL_MapRGB(s->format, 255, 255, 255);
	Uint32 color = SDL_MapRGB(s->format, 0, 255, 0);
	Uint32 *ptr = (Uint32 *)s->pixels;
	double x,y;
	for (j=0;j<s->h;j++)
	{
		y = (double)j*SY/DY - SY/2 - CY;
		for (i=0;i<s->w;i++)
		{
			//x = (rtodbl(gel(c, 1)) + CX + SX/2)*DX/SX;
			//y = (rtodbl(gel(c, 2)) + CY + SY/2)*DY/SY;
			x = (double)i*SX/DX - SX/2 - CX;
			if ((x-1.3)*(x-1.1) + (y+1)*(y+1) < 3.5)
				*ptr = color;
			else
				*ptr = color0;
			ptr++;
		}
		ptr += (s->pitch/4 - s->w);
	}*/
}

Complexe Ctoc (GEN c)
{
	double x,y;
	CtoD(c, &x, &y);
	return I()*y + x;
}

void Mtom ()
{
	int k, x, y;
	for (k=0;k<NG;k++)
	{
		for (y=0;y<2;y++)
		{
			for (x=0;x<2;x++)
			{
				gf[k].m[x][y] = Ctoc(gcoeff(g[k], x+1, y+1));
			}
		}
	}
}

void InitSem () //initialise les générateurs du semi-groupe
{
	infini = gp_read_str("10000000. + 10000000.*I");
	
	g[0] = fix(gp_read_str("-1."), gp_read_str("1."), gp_read_str("3.+1.*I")); //gp_read_str("1.+1.*I"));//gp_read_str("3.+1.*I")); 
	g[1] = fix(gp_read_str("-1.*I"), gp_read_str("1.*I"), gp_read_str("2. - 1.*I")); //gp_read_str("2. - 1.*I"));//gp_read_str("2. - 1.*I"));
	//g[1] = fix(gp_read_str("0."), gp_read_str("0."), gp_read_str("2. - 2.*I"));//gp_read_str("2. - 1.*I"));
	
	Mtom();
	
	SX_ = dbltor(SX);
	SY_ = dbltor(SY);
	CX_ = dbltor(CX + SX/2.);
	CY_ = dbltor(CY + SY/2.);
}

GEN apply (GEN c, int gen) //applique le générateur gen au complexe c
{
	GEN M = g[gen];
	GEN q = gadd(gmul(gcoeff(M,2,1), c), gcoeff(M,2,2));
	if (gequal0(q))
		return infini;
	else
		return gdiv(gadd(gmul(gcoeff(M,1,1), c), gcoeff(M,1,2)), q);
}

GEN apply (GEN M, GEN c) //applique la matrice M au complexe c
{
	GEN q = gadd(gmul(gcoeff(M,2,1), c), gcoeff(M,2,2));
	if (gequal0(q))
		return infini;
	else
		return gdiv(gadd(gmul(gcoeff(M,1,1), c), gcoeff(M,1,2)), q);
}

Complexe applyF (Matrice M, Complexe c) //applique la matrice M au complexe c
{
	Complexe q = M.m[1][0]*c + M.m[1][1];
	if (q == 0)
		return r(100000000.);
	else
		return (M.m[0][0]*c + M.m[0][1])/q;
}

GEN apply_inv (GEN c, int gen) //applique l'inverse du générateur gen au complexe c
{
	GEN M = g[gen];
	GEN q = gsub(gcoeff(M,1,1), gmul(gcoeff(M,2,1), c));
	if (gequal0(q))
		return infini;
	else
		return gdiv(gsub(gmul(gcoeff(M,2,2), c), gcoeff(M,1,2)), q);
}

Complexe apply_invF (Complexe c, int gen) //applique l'inverse du générateur gen au complexe c
{
	Matrice M = gf[gen];
	Complexe q = M.m[0][0] - M.m[1][0]*c;
	if (q == 0)
		return r(1000000000.);
	else
		return (M.m[1][1]*c - M.m[0][1])/q;
}

GEN fix (GEN p1, GEN p2, GEN p) //trouve une isométrie de points fixes p1, p2, et avec un paramètre complexe p
{
	GEN M = zeromatcopy(2, 2);
	
	gcoeff(M,1,1) = gcopy(p);
	gcoeff(M,1,2) = gneg(gmul(p1, p2));
	gcoeff(M,2,1) = dbltor(1.);
	gcoeff(M,2,2) = gsub(p, gadd(p1, p2));
	
	return M;
}

void CtoD (GEN c, double *x, double *y)
{
	if (typ(c) == t_REAL) // || typ(c) == t_INT || typ(c) == t_FRAC)
	{
		//printf("reel...\n");
		*x = rtodbl(c);
		*y = 0;
	}else if (typ(c) == t_COMPLEX)
	{
		//pari_printf("complex %Ps (%Ps, %Ps) ...\n", c, gel(c, 1), gel(c, 2));
		*x = rtodbl(gel(c, 1));
		*y = rtodbl(gel(c, 2));
	}
}

GEN DtoC (double x, double y)
{
	return mkcomplex(dbltor(x), dbltor(y));
}

void draw (SDL_Surface *s, GEN c, Uint32 color)
{
	int x,y;
	if (typ(c) == t_REAL) // || typ(c) == t_INT || typ(c) == t_FRAC)
	{
		//printf("reel...\n");
		x = (rtodbl(c) + CX + SX/2)*s->w/SX;
		y = 0;
	}else if (typ(c) == t_COMPLEX)
	{
		//pari_printf("complex %Ps (%Ps, %Ps) ...\n", c, gel(c, 1), gel(c, 2));
		x = (rtodbl(gel(c, 1)) + CX + SX/2)*s->w/SX;
		y = (rtodbl(gel(c, 2)) + CY + SY/2)*s->h/SY;
	}else
	{
		pari_printf("%Ps : type incorrect !\n", c);
	}
	if (x >= 0 && x < s->w && y >= 0 && y < s->h)
	{
		*((Uint32 *)s->pixels + x + y*(s->pitch)/4) = color; // *((Uint32 *)s->pixels + x + y*(s->pitch)/4) xor color;
	}
}

void drawF (SDL_Surface *s, Complexe c, Uint32 color)
{
	int x,y;
	x = (c.x + CX + SX/2)*s->w/SX;
	y = (c.y + CY + SY/2)*s->h/SY;
	if (x >= 0 && x < s->w && y >= 0 && y < s->h)
	{
		*((Uint32 *)s->pixels + x + y*(s->pitch)/4) = color; // *((Uint32 *)s->pixels + x + y*(s->pitch)/4) xor color;
	}
}

void Draw (SDL_Surface *s, bool flip)
{
	printf("Find1...\n");
	GEN c0 = Find1();
	
	Uint32 color = SDL_MapRGB(s->format, 0, 0, 0);
	
	pari_printf("Point choisi de l'ensemble limite : %Ps\n", c0);
	
	GEN c = c0;
	
	pari_sp av = avma;
	
	int i;
	for (i=0;i<NITER;i++)
	{
		if (i%100 == 0)
		{
			avma = av;
			c = c0;
		}
#if VERB >= 100	
		pari_printf("c = %Ps\n", c);
#endif
		draw(s, c, color);
		c = apply(c, rand()%2);
		if (flip)
		{
			if (i%1000000 == 0)
			{
				DispS(s);
			}
		}
	}
}

clock_t t = 0, rt = 0;

void Draw3 (SDL_Surface *s, GEN *pts, int npts, GEN PX, GEN PY, bool flip)
{		
	pari_sp av = avma;
	
	//teste si les points sont assez proches
	int i;
	bool ok = true;
	for (i=1;i<npts;i++)
	{
		if (gcmp(gabs(gsub(gel(pts[0],1), gel(pts[i],1)), 0), PX) > 0)
		{
			ok = false;
			break;
		}
		if (gcmp(gabs(gsub(gel(pts[0],2), gel(pts[i],2)), 0), PY) > 0)
		{
			ok = false;
			break;
		}
	}
	
	if (ok)
	{
		//on dessine le point
		draw(s, pts[0], SDL_MapRGB(s->format, 0, 0, 0));
		
		t = clock();
		if ((t - rt)/CLOCKS_PER_SEC > 10)
		{
			rt = t;
			DispS(s);
		}
	}else
	{
		//on itère une fois de plus
		int i,j;
		GEN *pts2 = (GEN *)malloc(sizeof(GEN)*npts);
		for (i=0;i<NG;i++)
		{
			for (j=0;j<npts;j++)
			{
				pts2[j] = apply(pts[j], i);
			}
			av = avma;
			Draw3(s, pts2, npts, PX, PY, flip);
			avma = av;
		}
		free(pts2);
	}
}

bool Draw4 (SDL_Surface *s, GEN m, GEN *pts, int npts, GEN PX, GEN PY, bool flip, int nitermax)
{		
	pari_sp av = avma;
	
	if (!nitermax)
		return true;
	
	//applique la matrice m aux points
	GEN *pts2 = (GEN *)malloc(sizeof(GEN)*npts);
	int i;
	for (i=0;i<npts;i++)
	{
		pts2[i] = apply(m, pts[i]);
	}
	//teste si les points sont assez proches
	bool ok = true;
	for (i=1;i<npts;i++)
	{
		if (gcmp(gabs(gsub(gel(pts2[0],1), gel(pts2[i],1)), 0), PX) > 0)
		{
			ok = false;
			break;
		}
		if (gcmp(gabs(gsub(gel(pts2[0],2), gel(pts2[i],2)), 0), PY) > 0)
		{
			ok = false;
			break;
		}
	}
	
	if (!flip)
	{
		t = clock();
		if ((t - rt)/CLOCKS_PER_SEC > 2)
		{
			return false;
		}
	}
	
	if (ok)
	{
		//on dessine le point
		draw(s, pts2[0], SDL_MapRGB(s->format, 0, 0, 0));
		
		if (flip)
		{
			t = clock();
			if ((t - rt)/CLOCKS_PER_SEC > 30)
			{
				printf("disp !\n");
				DispS(s);
				rt = clock();
			}
		}
	}
	
	free(pts2);
	
	if (!ok)
	{
		//on itère une fois de plus
		for (i=0;i<NG;i++)
		{
			av = avma;
			if (!Draw4(s, gmul(m, g[i]), pts, npts, PX, PY, flip, nitermax-1))
				return false;
			avma = av;
		}
	}
	
	return true;
}

bool Draw4F (SDL_Surface *s, Matrice m, Complexe *pts, int npts, float PX, float PY, bool flip, int nitermax)
{		
	pari_sp av = avma;
	
	if (!nitermax)
		return true;
	
	//m.disp();
	
	//applique la matrice m aux points
	Complexe *pts2 = (Complexe *)malloc(sizeof(Complexe)*npts);
	int i;
	for (i=0;i<npts;i++)
	{
		pts2[i] = applyF(m, pts[i]);
		//pts2[i].disp();
	}
	//teste si les points sont assez proches
	bool ok = true;
	for (i=1;i<npts;i++)
	{
		if (fabs(pts2[0].x - pts2[i].x) > PX)
		{
			ok = false;
			break;
		}
		if (fabs(pts2[0].y - pts2[i].y) > PY)
		{
			ok = false;
			break;
		}
	}
	
	if (!flip)
	{
		t = clock();
		if (((t - rt)*2)/CLOCKS_PER_SEC > 1)
		{
			return false;
		}
	}
	
	if (ok)
	{
		//on dessine le point
		drawF(s, pts2[0], SDL_MapRGB(s->format, 0, 0, 0));
		/*
		for (i=0;i<npts;i++)
		{
			pts2[i].disp();
		}
		*/
		
		/*
		if (flip)
		{
			t = clock();
			if ((t - rt)/CLOCKS_PER_SEC > 10)
			{
				rt = t;
				DispS(s);
			}
		}
		*/
	}
	
	free(pts2);
	
	if (!ok)
	{
		/*
		//teste si les points sont en dehors de l'écran
		ok = false;
		for (i=1;i<npts;i++)
		{
			if (pts2[i].x >= -SX/2 - CX - bord)
			{
				ok = true;
				break;
			}
		}
		if (!ok)
			goto end; //les points sont tous sortis à gauche
		ok = false;
		for (i=1;i<npts;i++)
		{
			if (pts2[i].x <= SX/2 - CX - bord)
			{
				ok = true;
				break;
			}
		}
		if (!ok)
			goto end; //les points sont tous sortis à droite
		ok = false;
		for (i=1;i<npts;i++)
		{
			if (pts2[i].y >= -SY/2 - CY - bord)
			{
				ok = true;
				break;
			}
		}
		if (!ok)
			goto end; //les points sont tous sortis à gauche
		ok = false;
		for (i=1;i<npts;i++)
		{
			if (pts2[i].x <= SY/2 - CY - bord)
			{
				ok = true;
				break;
			}
		}
		end :
		if (ok)
		*/
		{
			//on itère une fois de plus
			for (i=0;i<NG;i++)
			{
				if (!Draw4F(s, m.prod(gf[i]), pts, npts, PX, PY, flip, nitermax-1))
					return false;
			}
		}
	}
	return true;
}

bool Draw4B (GEN m, GEN *pts, int npts, GEN PX, GEN PY, double *xmin, double *ymin, double *xmax, double *ymax)
{		
	pari_sp av = avma;
	
	//applique la matrice m aux points
	GEN *pts2 = (GEN *)malloc(sizeof(GEN)*npts);
	int i;
	for (i=0;i<npts;i++)
	{
		pts2[i] = apply(m, pts[i]);
	}
	//teste si les points sont assez proches
	bool ok = true;
	for (i=1;i<npts;i++)
	{
		if (gcmp(gabs(gsub(gel(pts2[0],1), gel(pts2[i],1)), 0), PX) > 0)
		{
			ok = false;
			break;
		}
		if (gcmp(gabs(gsub(gel(pts2[0],2), gel(pts2[i],2)), 0), PY) > 0)
		{
			ok = false;
			break;
		}
	}
	
	t = clock();
	if ((t - rt)/CLOCKS_PER_SEC > TRMAX)
	{
		printf(" ... trop lent !\n");
		return false;
	}
	
	if (ok)
	{
		double x,y;
		for (i=0;i<npts;i++)
		{
			//pari_printf("pts[%i] = %Ps, ", i, pts[i]);
			//on agrandit éventuellement les bornes
			if (typ(pts2[i]) == t_REAL) // || typ(c) == t_INT || typ(c) == t_FRAC)
			{
				//printf("reel...\n");
				x = rtodbl(pts2[i]);
				y = 0;
			}else if (typ(pts2[i]) == t_COMPLEX)
			{
				//pari_printf("complex %Ps (%Ps, %Ps) ...\n", c, gel(c, 1), gel(c, 2));
				x = rtodbl(gel(pts2[i], 1));
				y = rtodbl(gel(pts2[i], 2));
			}else
			{
				pari_printf("%Ps : type incorrect !\n", pts2[i]);
			}
			
			if (x < *xmin)
				*xmin = x;
			if (x > *xmax)
				*xmax = x;
			if (y < *ymin)
				*ymin = y;
			if (y > *ymax)
				*ymax = y;
		}
		//pari_printf("\n");
	}
	
	free(pts2);
	
	if (!ok)
	{
		//on itère une fois de plus
		for (i=0;i<NG;i++)
		{
			av = avma;
			if (!Draw4B(gmul(m, g[i]), pts, npts, PX, PY, xmin, ymin, xmax, ymax))
				return false;
			avma = av;
		}
	}
	return true;
}

void Draw3 (SDL_Surface *s, bool flip)
{
	pari_sp av = avma;
	printf("Draw3...\n");
	int npts = 5;
	GEN *pts = (GEN *)malloc(sizeof(GEN)*npts);
	printf(" Find1...\n");
	pts[0] = Find1();
	pts[1] = mkcomplex(dbltor(SX/2 - CX), dbltor(SY/2 - CY));
	pts[2] = mkcomplex(dbltor(-SX/2 - CX), dbltor(SY/2 - CY));
	pts[3] = mkcomplex(dbltor(SX/2 - CX), dbltor(-SY/2 - CY));
	pts[4] = mkcomplex(dbltor(-SX/2 - CX), dbltor(-SY/2 - CY));
	GEN PX = gdiv(dbltor(SX), dbltor(s->w));
	GEN PY = gdiv(dbltor(SY), dbltor(s->h));
	printf(" Rec...\n");
	avma = av;
	Draw3(s, pts, npts, PX, PY, flip);
}

bool Draw4 (SDL_Surface *s, bool flip)
{
	printf("Draw4...\n");
	int npts = 5;
	pari_sp av = avma;
	GEN *pts = (GEN *)malloc(sizeof(GEN)*npts);
	printf(" Find1...\n");
	pts[0] = Find1();
	pts[1] = mkcomplex(dbltor(SX/2 - CX), dbltor(SY/2 - CY));
	pts[2] = mkcomplex(dbltor(-SX/2 - CX), dbltor(SY/2 - CY));
	pts[3] = mkcomplex(dbltor(SX/2 - CX), dbltor(-SY/2 - CY));
	pts[4] = mkcomplex(dbltor(-SX/2 - CX), dbltor(-SY/2 - CY));
	GEN PX = gdiv(dbltor(FIN*SX), dbltor(s->w));
	GEN PY = gdiv(dbltor(FIN*SY), dbltor(s->h));
	printf(" Rec...\n");
	GEN m = matid(2);
	rt = clock();
	bool res = Draw4(s, m, pts, npts, PX, PY, flip, 1000000000);
	avma = av;
	return res;
}

bool Draw4F (SDL_Surface *s, bool flip, int nitermax)
{
	printf("Draw4F...\n");
	int npts = 5;
	Complexe *pts = (Complexe *)malloc(sizeof(Complexe)*npts);
	pts[0] = r(0);
	pts[1] = I()*(SY/2 - CY) + (SX/2 - CX);
	pts[2] = I()*(-SY/2 - CY) + (SX/2 - CX);
	pts[3] = I()*(SY/2 - CY) + (-SX/2 - CX);
	pts[4] = I()*(-SY/2 - CY) + (-SX/2 - CX);
	float PX =(float)(2*SX)/s->w;
	float PY = (float)(2*SY)/s->h;
	printf(" Rec...\n");
	Matrice m;
	m.unit();
	//gf[0].disp();
	//gf[1].disp();
	rt = clock();
	return Draw4F(s, m, pts, npts, PX, PY, flip, nitermax);
}

void FindBounds ()
{
	printf("Find bounds...\n");
	double xmin = 1000000., xmax = -1000000., ymin = 1000000., ymax = -1000000.;
	/**/
	int npts = 5;
	pari_sp av = avma;
	GEN *pts = (GEN *)malloc(sizeof(GEN)*npts);
	printf(" Find1...\n");
	pts[0] = Find1();
	pts[1] = mkcomplex(dbltor(SX/2 - CX), dbltor(SY/2 - CY));
	pts[2] = mkcomplex(dbltor(-SX/2 - CX), dbltor(SY/2 - CY));
	pts[3] = mkcomplex(dbltor(SX/2 - CX), dbltor(-SY/2 - CY));
	pts[4] = mkcomplex(dbltor(-SX/2 - CX), dbltor(-SY/2 - CY));
	GEN PX = dbltor(bord/PRECB); //gdiv(dbltor(2*SX), dbltor(s->w));
	GEN PY = dbltor(bord/PRECB); //gdiv(dbltor(2*SY), dbltor(s->h));
	pari_printf("PX = %Ps, PY = %Ps\n", PX, PY);
	printf(" Rec...\n");
	GEN m = matid(2);
	rt = clock();
	if (!Draw4B(m, pts, npts, PX, PY, &xmin, &ymin, &xmax, &ymax))
	{ //la fonction a échouée à trouver les bornes assez vite
	/**/
		printf("Re-Find1...\n");
		GEN c0 = Find1();
		
		pari_printf("Point choisi de l'ensemble limite : %Ps\n", c0);
		
		GEN c = c0;
		
		pari_sp av = avma;
		
		/*
		xmin = 1000000.;
		xmax = -1000000.;
		ymin = 1000000.;
		ymax = -1000000.;
		*/
		
		double x,y;
		
		int i;
		for (i=0;i<NITER;i++)
		{
			if (i%10000 == 0)
			{
				avma = av;
				c = c0;
			}
			if (i%100000 == 0)
			{
				avma = av;
				c0 = Find1();
				av = avma;
			}
	#if VERB >= 100	
			pari_printf("c = %Ps\n", c);
	#endif
			
			if (typ(c) == t_REAL) // || typ(c) == t_INT || typ(c) == t_FRAC)
			{
				//printf("reel...\n");
				x = rtodbl(c);
				y = 0;
			}else if (typ(c) == t_COMPLEX)
			{
				//pari_printf("complex %Ps (%Ps, %Ps) ...\n", c, gel(c, 1), gel(c, 2));
				x = rtodbl(gel(c, 1));
				y = rtodbl(gel(c, 2));
			}else
			{
				pari_printf("%Ps : type incorrect !\n", c);
				break;
			}
			
			//pari_printf("%Ps\n", c);
			//printf("x=%lf, y=%lf\n", x, y);
			
			if (x < xmin)
				xmin = x;
			if (x > xmax)
				xmax = x;
			if (y < ymin)
				ymin = y;
			if (y > ymax)
				ymax = y;
			
			c = apply(c, rand()%2);
		}
	/**/
	}
	avma = av;
	/**/
	
	printf("xmin = %lf, xmax = %lf, ymin = %lf, ymax = %lf\n", xmin, xmax, ymin, ymax);
	//redimensionne la zone de dessin
	SX = xmax - xmin + 2*bord;
	SY = ymax - ymin + 2*bord;
	CX = -(xmin + xmax)/2;
	CY = -(ymin + ymax)/2;
	//évite la déformation par rapport à DX, DY (étirement horizontal ou horizontal)
	if (DX*SY > DY*SX)
	{ //l'image était étirée en x
		SX = SY*DX/DY;
	}else
	{ //l'image était étirée en x
		SY = SX*DY/DX;
	}
}

Uint32 iter (GEN p, SDL_Surface *s, int n)
{
	Uint32 c = color0;
	if (n)
	{
		bool found = false;
		int k;
		pari_sp av = avma;
		for (k=0;k<NG;k++)
		{
			//calcule l'image inverse
			c = iter(apply_inv(p, k), s, n-1);
			if (c != color0)
			{
				found = true;
				break;
			}
		}
		avma = av;
	}else
	{
		int i2, j2;
		Uint32 *f = (Uint32 *)s->pixels;
		//regarde si p est dans le majorant
		i2 = (rtodbl(gel(p, 1)) + CX + SX/2)*s->w/SX;
		if (i2 < 0 || i2 >= s->w)
			return color0;
		j2 = (rtodbl(gel(p, 2)) + CY + SY/2)*s->h/SY;
		if (j2 < 0 || j2 >= s->h)
			return color0;
		c = *(f + i2 + j2*(s->pitch)/4);
	}
	return c;
}

Uint32 iterF (Complexe p, SDL_Surface *s, int n)
{
	Uint32 c = color0;
	if (n)
	{
		bool found = false;
		int k;
		for (k=0;k<NG;k++)
		{
			//calcule l'image inverse
			c = iterF(apply_invF(p, k), s, n-1);
			if (c != color0)
			{
				found = true;
				break;
			}
		}
	}else
	{
		int i2, j2;
		Uint32 *f = (Uint32 *)s->pixels;
		//regarde si p est dans le majorant
		i2 = (p.x + CX + SX/2)*s->w/SX;
		if (i2 < 0 || i2 >= s->w)
			return color0;
		j2 = (p.y + CY + SY/2)*s->h/SY;
		if (j2 < 0 || j2 >= s->h)
			return color0;
		c = *(f + i2 + j2*(s->pitch)/4);
	}
	return c;
}

void Iter (SDL_Surface *s, SDL_Surface *s2)
{
	int i,j,k;
	Uint32 color;
	Uint32 *f = (Uint32 *)s->pixels;
	Uint32 *d = (Uint32 *)s2->pixels;
	double x,y;
	int i2, j2;
	GEN p, p2;
	pari_sp av;
	for (j=0;j<s->h;j++)
	{
		//printf("j=%d\n", j);
		av = avma;
		y = (double)j*SY/s->h - SY/2 - CY;
		for (i=0;i<s->w;i++)
		{
			if (*(f + i + j*(s2->pitch)/4) == color0)
			{
				*d = color0;
			}else
			{
				x = (double)i*SX/s->w - SX/2 - CX;
				p = mkcomplex(dbltor(x), dbltor(y));
				*d = iter(p, s, NITER2);
			}
			d++;
		}
		DispS(s2);
		avma = av;
		d += (s->pitch/4 - s->w);
	}
}

void IterF (SDL_Surface *s, SDL_Surface *s2)
{
	int i,j,k;
	Uint32 color;
	Uint32 *f = (Uint32 *)s->pixels;
	Uint32 *d = (Uint32 *)s2->pixels;
	double x,y;
	int i2, j2;
	Complexe p, p2;
	for (j=0;j<s->h;j++)
	{
		printf("j=%d\n", j);
		y = (double)j*SY/s->h - SY/2 - CY;
		//printf("j=%d\n", j);
		for (i=0;i<s->w;i++)
		{
			if (*(f + i + j*(s2->pitch)/4) == color0)
			{
				*d = color0;
			}else
			{
				x = (double)i*SX/s->w - SX/2 - CX;
				p = I()*y + x;
				*d = iterF(p, s, MORC);
			}
			d++;
		}
		if (j%(10*DX/FX) == 0)
			DispS(s2);
		d += (s->pitch/4 - s->w);
	}
}

void Iter1 (SDL_Surface *s, SDL_Surface *s2)
{
	int i,j,k;
	Uint32 color;
	Uint32 *f = (Uint32 *)s->pixels;
	Uint32 *d = (Uint32 *)s2->pixels;
	double x,y;
	int i2, j2;
	GEN p, p2;
	pari_sp av;
	bool found;
	for (j=0;j<s->h;j++)
	{
		//printf("j=%d\n", j);
		av = avma;
		y = (double)j*SY/s->h - SY/2 - CY;
		for (i=0;i<s->w;i++)
		{
			if (*(f + i + j*(s2->pitch)/4) == color0)
			{
				*d = color0;
			}else
			{
				x = (double)i*SX/s->w - SX/2 - CX;
				
				p = mkcomplex(dbltor(x), dbltor(y));
				found = false;
				for (k=0;k<NG;k++)
				{
					//calcule l'image inverse
					p2 = apply_inv(p, k);
					//regarde si p2 est dans le majorant
					i2 = (rtodbl(gel(p2, 1)) + CX + SX/2)*s->w/SX;
					if (i2 < 0 || i2 >= s->w)
						continue;
					j2 = (rtodbl(gel(p2, 2)) + CY + SY/2)*s->h/SY;
					if (j2 < 0 || j2 >= s->h)
						continue;
					color = *(f + i2 + j2*(s2->pitch)/4);
					if (color != color0)
					{
						*d = color;
						found = true;
						break;
					}
				}
				if (!found)
					*d = color0;
			}
			d++;
		}
		avma = av;
		d += (s->pitch/4 - s->w);
	}
}

void Draw2 (SDL_Surface *s)
{
	printf("Dessin du majorant...\n");
	DrawMaj(s);
	
	printf("Alloc...\n");
	SDL_Surface *s2 = SDL_ConvertSurface(s, s->format, s->flags);
		
	pari_sp av = avma;
	
	printf("Iter...\n");
	
	int i;
	for (i=0;i<NITER2;i++)
	{
		printf("%d ", i);
		fflush(stdout);
		Iter1(s, s2);
		SDL_BlitSurface(s2, NULL, s, NULL);
		DispS(s);
	}
	printf(" done !\n");
	//if (NITER2%2)
	//	SDL_BlitSurface(s2, NULL, s, NULL);
	
	SDL_FreeSurface(s2);
}

void Draw2D (SDL_Surface *s)
{
	printf("Dessin direct du majorant...\n");
	DrawMaj(s);
	
	printf("Alloc...\n");
	SDL_Surface *s2 = SDL_ConvertSurface(s, s->format, s->flags);
		
	pari_sp av = avma;
	
	printf("Iter...\n");
	
	
	Iter(s, s2);
	SDL_BlitSurface(s2, NULL, s, NULL);
	DispS(s);
	
	printf(" done !\n");
	//if (NITER2%2)
	//	SDL_BlitSurface(s2, NULL, s, NULL);
	
	
	SDL_FreeSurface(s2);
}

void Draw2DF (SDL_Surface *s)
{
	printf("Dessin direct du majorant...\n");
	DrawMaj(s);
	
	printf("Alloc...\n");
	SDL_Surface *s2 = SDL_ConvertSurface(s, s->format, s->flags);
		
	pari_sp av = avma;
	
	printf("IterF...\n");
	
	int i;
	for (i=0;i<(float)NITER2/MORC;i++)
	{
		printf("\n******************* %d ********************\n\n", i);
		fflush(stdout);
		IterF(s, s2);
		SDL_BlitSurface(s2, NULL, s, NULL);
		DispS(s);
	}
	/*
	IterF(s, s2);
	SDL_BlitSurface(s2, NULL, s, NULL);
	DispS(s);
	*/
	
	printf(" done !\n");
	//if (NITER2%2)
	//	SDL_BlitSurface(s2, NULL, s, NULL);
	
	
	SDL_FreeSurface(s2);
}

GEN Find1 () //cherche 1 point dans l'ensemble limite
{
	pari_sp av = avma;
	GEN c = dbltor(0);
	int i;
	for (i=0;i<10000;i++)
	{
		c = apply(c, rand()%2);
	}
	return gerepilecopy(av, c);
}

typedef GEN GEN2[2];

void Choose (SDL_Surface *s) //permet à l'utilisateur de choisir les paramètres graphiquement
{
	SDL_Event e;
	int i; //paramètre que l'on choisis
	double x, y;
	double dx = 20., dy = 20.;
	NITER = 100000;
	SDL_EnableUNICODE(true);
	int mdraw = 0;
	GEN2 *f = (GEN2 *)malloc(sizeof(GEN2)*NG); //points fixes de chaque isométrie
	f[0][0] = gp_read_str("-1.");
	f[0][1] = gp_read_str("-1."); //gp_read_str("1.");
	f[1][0] = gp_read_str("1."); //gp_read_str("-1.*I");
	f[1][1] = gp_read_str("1."); //gp_read_str("1.*I");
	
	//for (i=0;i<NG;i++)
	//	g[i] = fix(f[i][0], f[i][1], mkcomplex(dbltor(0), dbltor(0)));
	
	i = 0;
	for (;;)
	{
		if (SDL_PollEvent(&e))
		{
			if (e.type == SDL_KEYDOWN)
			{
				switch (e.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						return;
					case SDLK_RETURN:
						FindBounds(); //recalcule les bornes
						break;
				}
				switch (e.key.keysym.unicode)
				{
					case '1':
						printf("i=%d\n", i);
						i = 1;
						break;
					case '0':
						printf("i=%d\n", i);
						i = 0;
						break;
					case '+':
						NITER = NITER*2;
						printf("NITER = %d\n", NITER);
						break;
					case '-':
						NITER = NITER/2;
						printf("NITER = %d\n", NITER);
						break;
					case 'a':
						mdraw = (mdraw+1)%3;
						break;
				}
			}
			if (e.type == SDL_MOUSEMOTION) //SDL_MOUSEBUTTONDOWN)
			{
				x = e.motion.x*dx/s->w - dx/2; //button
				y = e.motion.y*dy/s->h - dy/2;
				
				//gcoeff(g[i],1,1) = mkcomplex(dbltor(x), dbltor(y));
				g[i] = fix(f[i][0], f[i][1], mkcomplex(dbltor(x), dbltor(y)));
			}
		}
		SDL_FillRect(s, NULL, color0);
		switch (mdraw)
		{
			case 0:
				Draw(s, false);
				break;
			case 1:
				if (!Draw4(s, false))
					printf("trop long !\n");
				break;
			default:
				Mtom();
				if (!Draw4F(s, false, 1000))
					printf("trop long !\n");
		}
		//DispS(s);
		SDL_Flip(s);
	}
	pari_printf("a[0] = %Ps, a[1] = %Ps\n", gcoeff(g[0], 1, 1), gcoeff(g[1], 1, 1));
}

void DrawTest (SDL_Surface *s)
{
	SDL_FillRect(s, NULL, color0);
	SDL_Rect r;
	r.h = 1;
	r.w = s->w;
	r.x = 0;
	r.y = s->w/3;
	SDL_FillRect(s, NULL, SDL_MapRGB(s->format, 255, 0, 0));
}

int main (int nargs, char **args)
{
	srand(time(NULL));
	
	printf("DX=%d, DY=%d, MORC=%d\n", DX, DY, MORC);
	
	printf("Initialisation de pari...\n");
	pari_init(100000000,2);
	
	//long prec = 5;
	//setrealprecision(8, &prec);
	//printf("prec = %ld\n", prec);
	
	//outbrute(beta);
	printf("Initialisation de la SDL...\n");
	if (SDL_Init(SDL_INIT_VIDEO))
	{
		fprintf(stderr,"Initialisation de la SDL rate : %s\n",SDL_GetError());
		exit(EXIT_FAILURE);
	}
	
	printf("Creation de la surface...\n");
	SDL_Surface *s = SDL_CreateRGBSurface(SDL_SWSURFACE, DX, DY, 32, 0xff000000, 0x00ff0000, 0x0000ff00, 0x000000ff);
	printf("ouverture de l'ecran...\n");
    ecran = SDL_SetVideoMode(FX, FY, 32, SDL_HWSURFACE);
	if (!s)
	{
		printf("Pas assez de RAM !\n");
		return -1;
	}
	
	color0 = SDL_MapRGB(s->format, 255, 255, 255); //couleur par défaut (en dehors de l'image)
	SDL_FillRect(s, NULL, color0);
	
	/**/
	int i;
	if (nargs >= 2)
	{
		if (nargs == 2 || (nargs == 3 && *args[2] == '+'))
		{
			FILE *fi = fopen(args[1], "r");
			if (!fi)
			{
				printf("Impossible d'ouvrir le fichier d'infos %s !\n", args[1]);
				return -1;
			}
			printf("Lectures du fichier %s...\n", args[1]);
			
			if (fscanf(fi, "%d générateurs :", &NG) != 1)
			{
				printf("Erreur de lecture du nombre de generateurs.\n");
				return -1;
			}
			int i;
			double x1,y1, x2,y2, x3, y3, x4,y4;
			
			g = (GEN *)malloc(sizeof(GEN)*NG);
			gf = (Matrice *)malloc(sizeof(Matrice)*NG);
			InitSem();
			
			char txt[256];
			for (i=0;i<NG;)
			{
				if (feof(fi))
				{
					printf("Erreur : il y a moins de generateurs qu'annoncés.\n");
					return -1;
				}
				fgets(txt, 256, fi);
				if (sscanf(txt, "[[%lf + %lf*I, %lf + %lf*I], [%lf + %lf*I, %lf + %lf*I]]", &x1, &y1, &x2, &y2, &x3, &y3, &x4, &y4) != 8)
				{
					continue;				
				}
				gcoeff(g[i], 1, 1) = DtoC(x1, y1);
				gcoeff(g[i], 1, 2) = DtoC(x2, y2);
				gcoeff(g[i], 2, 1) = DtoC(x3, y3);
				gcoeff(g[i], 2, 2) = DtoC(x4, y4);
				i++;
			}
			
			Mtom(); //met à jour les générateurs floatants
			
			for (i=0;i<NG;i++)
				pari_printf("g[%d] = %Ps\n", i, g[i]);
			
			fclose(fi);
		}
	}else
	{
		g = (GEN *)malloc(sizeof(GEN)*NG);
		gf = (Matrice *)malloc(sizeof(Matrice)*NG);
		InitSem();
		for (i=0;i<NG;i++)
			pari_printf("g[%d] = %Ps\n", i, g[i]);
	}
	
	printf("NG = %d\n", NG);
	
	/*
	printf("Bornes...\n");
	FindBounds();
	printf("SX = %lf, SY = %lf, CX = %lf, CY = %lf\n", SX, SY, CX, CY);
	*/
	
	if (nargs == 1 || (nargs == 3 && *args[2] == '+'))
	{
		
		Choose(ecran);
		
	}
	/**/
	
	printf("Bornes...\n");
	TRMAX = 600;
	FindBounds();
	printf("SX = %lf, SY = %lf, CX = %lf, CY = %lf\n", SX, SY, CX, CY);
	
	/*
	/////////////test
	DrawTest(s);
	DispS(s);
	SDL_Surface *s3 = SDL_ConvertSurface(s, s->format, s->flags);
		
	pari_sp av = avma;
	
	printf("Iter...\n");
	Iter1(s, s3);
	SDL_BlitSurface(s3, NULL, s, NULL);
	DispS(s);
	SDL_FreeSurface(s3);
	//////////////////
	*/
	/**/
	
	//enregistre les infos du semi-groupe dans l'image
	char txt[256];
	FILE *fi = fopen("result.info", "w");
	if (fi)
	{
		fprintf(fi, "%d générateurs :\n", NG);
		int i;
		double x,y;
		for (i=0;i<NG;i++)
		{
			CtoD(gcoeff(g[i], 1, 1), &x, &y);
			fprintf(fi, "[[%.15lf + %.15lf*I, ", x, y);
			CtoD(gcoeff(g[i], 1, 2), &x, &y);
			fprintf(fi, "%.15lf + %.15lf*I], [", x, y);
			CtoD(gcoeff(g[i], 2, 1), &x, &y);
			fprintf(fi, "%.15lf + %.15lf*I, ", x, y);
			CtoD(gcoeff(g[i], 2, 2), &x, &y);
			fprintf(fi, "%.15lf + %.15lf*I]]\n", x, y);
		}
		fprintf(fi, "Les paramètres choisis graphiquement sont :\n");
		pari_outfile = fi;
		for (i=0;i<NG;i++)
		{
			pari_printf("%Ps\n", gsub(gcoeff(g[i], 2, 2), gadd(gcoeff(g[i], 1, 1), gdiv(gcoeff(g[i], 1, 2),gcoeff(g[i], 1, 1)))));
		}
		pari_outfile = stdout;
		fclose(fi);
	}else
	{
		printf("Impossible d'ouvrir le fichier d'infos !\n");
	}
	
	for (i=0;i<NG;i++)
		printf("gf[%d] = [[%f+%f*I, %f+%f*I], [%f+%f*I, %f+%f*I]]\n", i, gf[i].m[0][0].x, gf[i].m[0][0].y, gf[i].m[0][1].x, gf[i].m[0][1].y, gf[i].m[1][0].x, gf[i].m[1][0].y, gf[i].m[1][1].x, gf[i].m[1][1].y);

	printf("Dessin...\n");
	//Draw2DF(s);
	//Draw2(s);
	
	printf("Dessin2...\n");
	//Draw(s, true);
	Draw4(s, true);
	//Draw3(s, true);
	DispS(s);
	/**/
	
	/*
	draw(s, gp_read_str("-1. + 0.*I"), SDL_MapRGB(s->format, 0, 0, 0));
	draw(s, gp_read_str("1. + 0.*I"), SDL_MapRGB(s->format, 0, 0, 0));
	draw(s, gp_read_str("-1.*I"), SDL_MapRGB(s->format, 0, 0, 0));
	draw(s, gp_read_str("1.*I"), SDL_MapRGB(s->format, 0, 0, 0));
	draw(s, gp_read_str("0. + 0.*I"), SDL_MapRGB(s->format, 0, 0, 0));
	*/
	
	printf("Redimensionnement...\n");
	SDL_Surface *s2 = SDL_CreateRGBSurface(SDL_SWSURFACE, DX2, DY2, 32, 0xff000000, 0x00ff0000, 0x0000ff00, 0x000000ff);
	Copy(s, s2, NULL);
	
	printf("Enregistrement...\n");
	//SDL_SaveBMP(s2, "result.bmp");
	SaveJPEG (s2, "result_TEMP.jpg");
	
	system("wrjpgcom -cfile result.info < result_TEMP.jpg > result.jpg");
	
	remove("result_TEMP.jpg");
	
	SDL_Quit();
	printf("Goodbye !\n");
	return 0;
}